// tpeDoc.cpp : implementation of the CTpeDoc class
//

#include "math.h"

#include "stdafx.h"
#include "tpe.h"

#include "tpeDoc.h"
#include "ParametersDialog.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTpeDoc

IMPLEMENT_DYNCREATE(CTpeDoc, CDocument)

BEGIN_MESSAGE_MAP(CTpeDoc, CDocument)
	//{{AFX_MSG_MAP(CTpeDoc)
	ON_COMMAND(ID_SIMULATION_PARAMETERS, OnSimulationParameters)
	ON_COMMAND(ID_SIMULATION_CALCUL, OnSimulationCalcul)
	ON_COMMAND(ID_SIMULATION_EXECUTION, OnSimulationExecution)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTpeDoc construction/destruction

CTpeDoc::CTpeDoc():m_Mu(0.000001256637061)
{
	// TODO: add one-time construction code here

	m_intensite_conducteur=0.0;
	m_intensite_solenoide=0.0;
	m_longueur_conducteur=0.0;
	m_longueur_solenoide=0.0;
	m_masse_conducteur=0.0;
	m_nb_spire=0;
	m_longueur_piste=0.0;


	m_acceleration=0.0;
	m_B=0.0;
	m_temps=0.0;
	m_vitesse=0.0;
	m_position=0.0;
	m_delta_temps=0.0;

}

CTpeDoc::~CTpeDoc()
{
}

BOOL CTpeDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument())
		return FALSE;

	// TODO: add reinitialization code here
	// (SDI documents will reuse this document)

	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CTpeDoc serialization

void CTpeDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}
}

/////////////////////////////////////////////////////////////////////////////
// CTpeDoc diagnostics

#ifdef _DEBUG
void CTpeDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CTpeDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CTpeDoc commands

void CTpeDoc::OnSimulationParameters() 
{
	// TODO: Add your command handler code here
	CParametersDialog diag;

	diag.m_intensite_conducteur=m_intensite_conducteur;
	diag.m_intensite_solenoide=m_intensite_solenoide;
	diag.m_longueur_conducteur=m_longueur_conducteur;
	diag.m_longueur_solenoide=m_longueur_solenoide;
	diag.m_masse_conducteur=m_masse_conducteur;
	diag.m_nb_spire=m_nb_spire;
	diag.m_delta_temps=m_delta_temps;
	diag.m_longueur_piste=m_longueur_piste;

	if(diag.DoModal()==IDOK)
	{
		m_intensite_conducteur=diag.m_intensite_conducteur;
		m_intensite_solenoide=diag.m_intensite_solenoide;
		m_longueur_conducteur=diag.m_longueur_conducteur;
		m_longueur_solenoide=diag.m_longueur_solenoide;
		m_masse_conducteur=diag.m_masse_conducteur;
		m_nb_spire=diag.m_nb_spire;
		m_delta_temps=diag.m_delta_temps;
		m_longueur_piste=diag.m_longueur_piste;
	}

	
}


void CTpeDoc::Calcul_B()
{	

	if(m_longueur_solenoide>0)
		m_B=m_nb_spire*m_Mu*m_intensite_solenoide/m_longueur_solenoide;
	else
		m_B=0.0;
}

void CTpeDoc::Calcul_Acceleration()
{
	if(m_masse_conducteur>0)
		m_acceleration = m_intensite_conducteur*m_longueur_conducteur*m_B/m_masse_conducteur;
	else
		m_acceleration = 0.0;

}

void CTpeDoc::OnSimulationCalcul() 
{
	// TODO: Add your command handler code here
	Calcul_B();
	Calcul_Acceleration();
	UpdateAllViews(0,0,0);	
}


void CTpeDoc::OnSimulationExecution() 
{
	// TODO: Add your command handler code here
	double delta_refresh=m_delta_temps;
	double last_refresh=0.0;

	m_temps=0.0;
	m_vitesse=0.0;
	m_position=0.0;
	SYSTEMTIME system_time;
	FILETIME file_time;
	LARGE_INTEGER time;
	LARGE_INTEGER old_time;
	GetSystemTime(&system_time);
	SystemTimeToFileTime(&system_time,&file_time);
	time.LowPart=file_time.dwLowDateTime;
	time.HighPart=file_time.dwHighDateTime;

	old_time = time;

	if(m_acceleration>0)
	{
		double delta_time;

		while(m_position<m_longueur_piste)
		{	
			GetSystemTime(&system_time);
			SystemTimeToFileTime(&system_time,&file_time);
			time.LowPart=file_time.dwLowDateTime;
			time.HighPart=file_time.dwHighDateTime;
			delta_time = (time.QuadPart-old_time.QuadPart)/10000000.0;
		
			if( delta_time >= m_delta_temps)
			{
				m_temps+=m_delta_temps;
				m_vitesse=m_temps*m_acceleration;
				m_position=m_acceleration*m_temps*m_temps/2;
				old_time=time;
				if( (m_temps-last_refresh) >= delta_refresh)
				{
					UpdateAllViews(0,0,0);
					last_refresh=m_temps;
				}
			}

			MSG msg;
			for(int i=0;i<100;i++)
			{
				if(PeekMessage( &msg,NULL,0,0,PM_REMOVE))
				{
					TranslateMessage(&msg);
					DispatchMessage(&msg);
				}
	
//		void CTpeDoc::OnSimulationConversion()
			{	
		if(m_vitesse>0)
		m_info = m_vitesse*3.6;
		else 
		m_info = 0.0;
		}
			}
				}
					}
						}