// tpeDoc.h : interface of the CTpeDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_TPEDOC_H__4A1484EC_1B3E_11D7_8EC0_A7ACCBF06230__INCLUDED_)
#define AFX_TPEDOC_H__4A1484EC_1B3E_11D7_8EC0_A7ACCBF06230__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CTpeDoc : public CDocument
{
protected: // create from serialization only
	CTpeDoc();
	DECLARE_DYNCREATE(CTpeDoc)

	double	m_intensite_conducteur;
	double	m_intensite_solenoide;
	double	m_longueur_conducteur;
	double	m_longueur_solenoide;
	double	m_masse_conducteur;
	int		m_nb_spire;
	double  m_longueur_piste;
	double  m_info;

	double m_B;
	double m_acceleration;
	const double m_Mu;
	double m_temps;
	double m_vitesse;
	double m_position;
	double m_delta_temps;

// Attributes
public:

// Operations
public:
	void Calcul_B();
	void Calcul_Acceleration();


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTpeDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CTpeDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	double Get_intensite_conducteur() const
	{ return m_intensite_conducteur; }

	double Get_intensite_solenoide() const
	{ return m_intensite_solenoide; }

	double Get_longueur_conducteur() const
	{ return m_longueur_conducteur; }

	double Get_longueur_solenoide() const
	{ return m_longueur_solenoide; }

	double Get_masse_conducteur() const
	{ return m_masse_conducteur; }

	int Get_nb_spire() const
	{ return m_nb_spire; }

protected:

// Generated message map functions
public:
	//{{AFX_MSG(CTpeDoc)
	afx_msg void OnSimulationParameters();
	afx_msg void OnSimulationCalcul();
	afx_msg void OnSimulationExecution();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_TPEDOC_H__4A1484EC_1B3E_11D7_8EC0_A7ACCBF06230__INCLUDED_)
